
import os, pickle
from searcher import TASK_LIST
from maketables import Function

def fix(name):
    if name.startswith("USR "):
        name = name[4:]

    if name.startswith("janne"):
        return "janne"
    if name == "insertso":
        return "insertsort"
    if name == "bs":
        return "binarysearch"

    return name

def run():
    total = 0
    by_name = pickle.load(file("biw.dat"))
    out = file("res/tasks.tex", "wt")
    out.write(r"""
\begin{tabular}{|l|r|r|r|}
\hline
Task Name   & Code Size     & Data Size     & Stack Size \\
\hline
""")

    for name in sorted(TASK_LIST):
        fields = None
        for line in os.popen("mb-size app/%s.o" % name):
            if line.find("  text  ") == -1:
                fields = line.split()

        assert fields != None
        fn = by_name[name]
        data = int(fields[1]) + int(fields[2])

        out.write(r"%s & %u & %u & %u \\" % (
                fix(name), fn.code_size, data, fn.stack_size))
        out.write("\n")
        total += fn.code_size + data + fn.stack_size

    out.write(r"""
%% total space %u
\hline
\end{tabular}
""" % total)
    out.close()

    out = file("res/tasks2.tex", "wt")
    out.write(r"""
\begin{tabular}{|l|r|r|r|}
\hline
Task Name   & Code & Data & Stack \\
            & Blocks & Blocks & Blocks \\
\hline
""")

    for name in sorted(TASK_LIST):
        fn = by_name[name]
        for sfn in [fn] + fn.subtask:
            if sfn != fn:
                # subtask
                out.write(r"$\rightarrow$~")
            out.write(r"%s & %u & %u & %u \\" % (
                    fix(sfn.name), 
                    sfn.code_blocks, sfn.heap_blocks, sfn.stack_blocks))
            out.write("\n")

    out.write(r"""
\hline
\end{tabular}
""")
    out.close()

if __name__ == "__main__":
    run()

