
import random, os

from searcher import S_DIR, adv_parse
from results0 import fix


def run():
    task_data = dict()
    adv_parse(task_data, "report_overhead.txt", None)
    out = file("res/overhead.tex", "wt")
    out.write(r"""
\begin{tabular}{|r|r|r|}
\hline
Code Blocks & Stack Blocks & Overhead \\
\hline
""")

    matrix = dict()
    for y in [1, 2, 3, 4]:
        for z in [0, 1, 2]:
            td = task_data[(None, "USR y%u_z%u" % (y, z))]
            wcet = max(td.wcets)
            out.write(r"%u & %u & %u \\" % (y, z, wcet))
            out.write("\n")
            matrix[(y, z)] = wcet

    out.flush()

    stack_cost = matrix[(1, 2)] - matrix[(1, 1)]
    for y in [1, 2, 3, 4]:
        assert (matrix[(y, 1)] - matrix[(y, 0)]) >= stack_cost
        assert (matrix[(y, 2)] - matrix[(y, 1)]) == stack_cost
        n = matrix[(y, 1)] - stack_cost
        assert (matrix[(y, 0)] <= n)
        matrix[(y, 0)] = n

    code_cost = matrix[(2, 0)] - matrix[(1, 0)]
    for z in [0, 1, 2]:
        assert code_cost == matrix[(2, z)] - matrix[(1, z)]
        assert code_cost == matrix[(3, z)] - matrix[(2, z)]
        assert code_cost == matrix[(4, z)] - matrix[(3, z)]
        matrix[(0, z)] = matrix[(1, z)] - code_cost

    out.write(r"\hline")
    out.write("\n")
    out.write(r"$y$ & $z$ & $%uy +$ \\" % code_cost)
    out.write("\n")
    out.write(r"    &     & $%uz + %u$ \\" % (
            stack_cost, matrix[(0, 0)]))
    out.write("\n")

    out.write(r"""
\hline
\end{tabular}
""")
    out.close()

    
    



if __name__ == "__main__":
    run()

